#include <boost/units/detail/utility.hpp>
#include <iostream>
#include <typeinfo>

namespace bud = boost::units::detail;
using namespace std;

namespace ns
{
  class MyClass {};
  struct MyStruct {};
}

void test()
{
  cout << "int          = " << typeid(int).name() << endl;
  cout << "int*         = " << typeid(int*).name() << endl;
  cout << "MyClass      = " << typeid(ns::MyClass).name() << endl;
  cout << "MyClass*     = " << typeid(ns::MyClass*).name() << endl;
  cout << "MyStruct     = " << typeid(ns::MyStruct).name() << endl;
  cout << "MyStruct*    = " << typeid(ns::MyStruct*).name() << endl;
  cout << "std::string  = " << typeid(std::string).name() << endl;
  cout << "std::string* = " << typeid(std::string*).name() << endl;
}

void demangle_test()
{
  cout << "int          = " << bud::demangle(typeid(int).name()) << endl;
  cout << "int*         = " << bud::demangle(typeid(int*).name()) << endl;
  cout << "MyClass      = " << bud::demangle(typeid(ns::MyClass).name()) << endl;
  cout << "MyClass*     = " << bud::demangle(typeid(ns::MyClass*).name()) << endl;
  cout << "MyStruct     = " << bud::demangle(typeid(ns::MyStruct).name()) << endl;
  cout << "MyStruct*    = " << bud::demangle(typeid(ns::MyStruct*).name()) << endl;
  cout << "std::string  = " << bud::demangle(typeid(std::string).name()) << endl;
  cout << "std::string* = " << bud::demangle(typeid(std::string*).name()) << endl;
}

int main()
{
  test();
  cout << endl;
  demangle_test();
  return 0;
}
